package osalpr1;

import java.util.Collections;
import java.util.PriorityQueue;
import java.util.Comparator;
import java.util.Iterator;
import java.util.Vector;
import es.upv.dsic.gti_ia.jgomas.CTerrainMap;
import es.upv.dsic.gti_ia.jgomas.Vector3D;

public final class CAstar{
	private CNode source, target;
	private CTerrainMap m_Map;
	private static Vector3D[] _homePath = null;
	private static Vector3D[] _targetPath = null;
	private double sourceX, sourceZ;
	private static CAstar theCAstar = null;
	private static double MaxDst = 40;

	
	//Nos aseguramos de que solo hay una instancia de CAstar
	public static synchronized CAstar getInstance(CTerrainMap m_Map_) {
		if(theCAstar == null) {
			theCAstar = new CAstar(m_Map_);
		}
		return theCAstar;
	}
	
	//Constructor protegido
	public CAstar(CTerrainMap m_Map_){
		m_Map = m_Map_;
	};
	
	protected void SetParms(double sourceX_, double sourceZ_){
		source = new CNode(sourceX_,sourceZ_);
		target = new CNode(m_Map.GetTargetX(),m_Map.GetTargetZ());
		sourceX = sourceX_;
		sourceZ = sourceZ_;
	};
	
	protected void SetParms(double sourceX_, double sourceZ_, double targetX_, double targetZ_){
		source = new CNode(sourceX_,sourceZ_);
		target = new CNode(targetX_,targetZ_);
		sourceX = sourceX_;
		sourceZ = sourceZ_;
	};

	public Vector3D[] getPathToInitialFlag(double sourceX_, double sourceZ_, double targetX_, double targetZ_){
		SetParms(sourceX_, sourceZ_, targetX_, targetZ_);
		myPriorityQueue openList = new myPriorityQueue();
		ClosedList closedList = new ClosedList(32,32);
		CNode workingNode;

		Boolean pathFound = false;
		openList.add(source);
		while (!openList.isEmpty()&&!pathFound){
			workingNode = (CNode) openList.poll();
			closedList.put(workingNode.getx(),workingNode.getz());
			for (int x=-1;x<2;++x){				
				for(int z=-1;z<2;++z){
					if (x==0&&z==0) continue;
					if (closedList.is(workingNode.getx()+x,workingNode.getz()+z)) continue;
					if (!m_Map.CanWalk(workingNode.getx()+x, workingNode.getz()+z)) continue;
					//El asunto de los "rascones"
					if (((x*x)+(z*z)==2)&&(x!=z)){
						if (x==1){
							if(!m_Map.CanWalk(workingNode.getx(), workingNode.getz()+z)) continue;
						}
						else{
							if(!m_Map.CanWalk(workingNode.getx()+x, workingNode.getz())) continue;
						}
					}
					myPriorityQueue auxOpenList = new myPriorityQueue();
					CNode cn = null;
					Boolean esta = false;
					Iterator<CNode> it = openList.iterator();
					while ( it.hasNext() ){
						cn = (CNode) it.next();
						if ((cn.getx()== (workingNode.getx()+x)) && (cn.getz()==(workingNode.getz()+z))){
							//Est
							if (workingNode.getg()+(((x*x)+(z*z)==1)?10:14)<cn.getg()){
								cn.setfather(workingNode);
								//la h no la ponemos pq ya se hizo al crear el nodo (ver nota 1)
								cn.setg(workingNode.getg()+(((x*x)+(z*z)==1)?10:14));
								//openList.remove(cn);
								//openList.removeAll(Collections.singletonList(cn));
								//openList.add(cn);	
							}
							esta = true;
							//break;						
						}						
						auxOpenList.add(cn);						
					}
					if (!esta){
						CNode new_node = new CNode(workingNode.getx()+x,workingNode.getz()+z);
						new_node.setfather(workingNode);
						new_node.setg(workingNode.getg() + (((x*x)+(z*z)==1)?10:14));
						//nota 1
						new_node.seth(manhattan(new_node));
						auxOpenList.add(new_node);
						if (new_node.getx() == target.getx() && new_node.getz() == target.getz()){
							target = new_node;
							pathFound = true;
						}
					}
					openList = auxOpenList;
					if (pathFound) break;
				}
				if (pathFound) break;
			}
		}

		//Estimamos el tamao inicial del vector auxiliar
		Vector <Vector3D> nodesPath = new Vector<Vector3D>(manhattan(source));
		//Sustituimos las coordenadas del nodo final calculado por las reales, la justificacion es que:
		//Si el punto representativo del nodo final (esquina sup. izqda.) fue alcanzable desde el nodo anterior sin tropezar en esquinas, 
		//entonces cualquier punto del nodo final es alcanzable desde el nodo anterior sin tropezar en esquinas tampoco. 
		nodesPath.add(new Vector3D(targetX_,0,targetZ_));
		CNode next = target.getfather();
		while (next!=null){
			nodesPath.add(new Vector3D((next.getx()*8)+4,0,(next.getz()*8)+4));
			next = next.getfather();
		}

		//Vamos a desestimar el primer nodo a visitar de la ida por lo que no reservamos espacio para l, la justificacione es que:
		//Si el segundo nodo a visitar fue alcanzable desde el punto representativo del nodo inicial (esquina sup. izqda.) sin tropezar en esquinas,
		//entonces desde cualquier punto del nodo inicial se podr alcanzar el punto representativo del segundo nodo sin tropezar en esquinas
		Vector3D[] _targetPath;
		if (nodesPath.size()==1){		
			_targetPath = new Vector3D[1];
			_targetPath[0]=nodesPath.elementAt(0);
		}
		else{
			_targetPath = new Vector3D[nodesPath.size()-1];
			for (int index = 0;index < _targetPath.length; index++){
				_targetPath[index]=nodesPath.elementAt(nodesPath.size()-(index+2));
			}
		}
		return _targetPath;
	};
	
	//Mtodo sincronizado para evitar ejecuciones concurrentes. Este mtodo se usa slo para obtener el camino a la bandera y la vuelta.
	public synchronized void getPathToInitialFlag(double sourceX_, double sourceZ_, Holder<Vector3D[]> targetPath, Holder<Vector3D[]> homePath){
		if (_targetPath != null){
			//Este camino ya se calculo antes
			double distance = Math.sqrt(Math.pow(sourceX-sourceX_, 2)+Math.pow(sourceZ-sourceZ_, 2));
			if (distance<MaxDst){
				//El solicitante esta cerca de la posicin del agente que pidio esta ruta con anterioridad. Se le da la ruta ya calculada.
				targetPath.value = new Vector3D[_targetPath.length];
				System.arraycopy(_targetPath,0,targetPath.value,0,_targetPath.length);
				homePath.value = new Vector3D[_homePath.length];
				System.arraycopy(_homePath,0,homePath.value,0,_homePath.length);
				return;
			}
			else {
				//El solicitante no esta cerca del anterior solicitante. Se le calcula la ruta a l.
				_targetPath = null;
				_homePath = null;
			}	
		}

		//Nadie ha pedido calcular este camino antes y por tanto se calcula
		SetParms(sourceX_, sourceZ_);
		myPriorityQueue openList = new myPriorityQueue();
		ClosedList closedList = new ClosedList(32,32);
		CNode workingNode;

		Boolean pathFound = false;
		openList.add(source);
		while (!openList.isEmpty()&&!pathFound){
			workingNode = (CNode) openList.poll();
			closedList.put(workingNode.getx(),workingNode.getz());
			for (int x=-1;x<2;++x){				
				for(int z=-1;z<2;++z){
					if (x==0&&z==0) continue;
					if (closedList.is(workingNode.getx()+x,workingNode.getz()+z)) continue;
					if (!m_Map.CanWalk(workingNode.getx()+x, workingNode.getz()+z)) continue;
					//El asunto de los "rascones"
					if (((x*x)+(z*z)==2)&&(x!=z)){
						if (x==1){
							if(!m_Map.CanWalk(workingNode.getx(), workingNode.getz()+z)) continue;
						}
						else{
							if(!m_Map.CanWalk(workingNode.getx()+x, workingNode.getz())) continue;
						}
					}
					myPriorityQueue auxOpenList = new myPriorityQueue();
					CNode cn = null;
					Boolean esta = false;
					Iterator<CNode> it = openList.iterator();
					while ( it.hasNext() ){
						cn = (CNode) it.next();
						if ((cn.getx()== (workingNode.getx()+x)) && (cn.getz()==(workingNode.getz()+z))){
							//Est
							if (workingNode.getg()+(((x*x)+(z*z)==1)?10:14)<cn.getg()){
								cn.setfather(workingNode);
								//la h no la ponemos pq ya se hizo al crear el nodo (ver nota 1)
								cn.setg(workingNode.getg()+(((x*x)+(z*z)==1)?10:14));
								//openList.remove(cn);
								//openList.removeAll(Collections.singletonList(cn));
								//openList.add(cn);	
							}
							esta = true;
							//break;						
						}						
						auxOpenList.add(cn);						
					}
					if (!esta){
						CNode new_node = new CNode(workingNode.getx()+x,workingNode.getz()+z);
						new_node.setfather(workingNode);
						new_node.setg(workingNode.getg() + (((x*x)+(z*z)==1)?10:14));
						//nota 1
						new_node.seth(manhattan(new_node));
						auxOpenList.add(new_node);
						if (new_node.getx() == target.getx() && new_node.getz() == target.getz()){
							target = new_node;
							pathFound = true;
						}
					}
					openList = auxOpenList;
					if (pathFound) break;
				}
				if (pathFound) break;
			}
		}

		//Estimamos el tamao inicial del vector auxiliar
		Vector <Vector3D> nodesPath = new Vector<Vector3D>(manhattan(source));
		//Sustituimos las coordenadas del nodo final calculado por las reales, la justificacion es que:
		//Si el punto representativo del nodo final (esquina sup. izqda.) fue alcanzable desde el nodo anterior sin tropezar en esquinas, 
		//entonces cualquier punto del nodo final es alcanzable desde el nodo anterior sin tropezar en esquinas tampoco. 
		nodesPath.add(new Vector3D(m_Map.GetTargetX(),0,m_Map.GetTargetZ()));
		CNode next = target.getfather();
		while (next!=null){
			nodesPath.add(new Vector3D((next.getx()*8)+4,0,(next.getz()*8)+4));
			next = next.getfather();
		}

		//Vamos a desestimar el primer nodo a visitar de la ida por lo que no reservamos espacio para l, la justificacione es que:
		//Si el segundo nodo a visitar fue alcanzable desde el punto representativo del nodo inicial (esquina sup. izqda.) sin tropezar en esquinas,
		//entonces desde cualquier punto del nodo inicial se podr alcanzar el punto representativo del segundo nodo sin tropezar en esquinas
		//Vector3D[] targetPath = new Vector3D[nodesPath.size()-1];				
		_targetPath = new Vector3D[nodesPath.size()-1];

		for (int index = 0;index < _targetPath.length; index++){
			_targetPath[index]=nodesPath.elementAt(nodesPath.size()-(index+2));
		}
		//Calculamos la ruta de vuelta.
		//Desestimamos el primer punto, la justificacin es que:
		//El primer punto es donde est la bandera, y ya estamos alli, asi que para qu visitarlo, pasamos directamente al que fue anterior en el camino de ida
		_homePath = new Vector3D[nodesPath.size()-1];
		for (int index = 0;index < _homePath.length; index++){
			_homePath[index]=nodesPath.elementAt(index+1);
		}

		//Sustituimos el nodo final de la vuelta (el origen) por las coordenadas de las que partimos al inicio del viaje, la justificacin es que:
		//Queremos acabar donde empezamos, no en el punto representativo del nodo en el que empezamos.
		_homePath[_homePath.length-1].x=sourceX;
		_homePath[_homePath.length-1].z=sourceZ;

		targetPath.value = new Vector3D[_targetPath.length];
		System.arraycopy(_targetPath,0,targetPath.value,0,_targetPath.length);
		homePath.value = new Vector3D[_homePath.length];
		System.arraycopy(_homePath,0,homePath.value,0,_homePath.length);
	};

	private int manhattan(CNode c_node){
		//return (10*(Math.abs(c_node.getx()-target.getx()) + Math.abs(c_node.getz()-target.getz())));
		int h_diagonal= Math.min(Math.abs(c_node.getx()-target.getx()),Math.abs(c_node.getz()-target.getz()));
		int h_straight= Math.abs(c_node.getx()-target.getx()) + Math.abs(c_node.getz()-target.getz());
		return (14 * h_diagonal + 10 * (h_straight - 2*h_diagonal));
	}

	private class ClosedList{
		private Boolean list[][];;
		private int x, z;
		public ClosedList(int x_, int z_){
			list = new Boolean[x_][z_];
			for (int x=0;x<x_;++x) for(int z=0;z<z_;++z) list[x][z] = false;
			x=x_;
			z=z_;
		}
		public Boolean is(int x_, int z_){
			if (x_<0||x_>=x||z_<0||z_>=z) return false;
			return list[x_][z_];			
		}
		public void put(int x_, int z_){
			if (x_<0||x_>=x||z_<0||z_>=z) return;
			list[x_][z_] = true;
		}
	}

	private class myPriorityQueue extends PriorityQueue<CNode>{		
		public myPriorityQueue(){
			super(20,new myComparator());
		}
	};

	private class myComparator implements Comparator<CNode> {
		public int compare(CNode node1, CNode node2) {
			if( (node1.getg() + node1.geth()) < (node2.getg() + node2.geth())) return -1;
			else 
				if( (node1.getg() + node1.geth()) > (node2.getg() + node2.geth())) return 1;
				else return 0;
		};
	}
}

